
// Tilt SensingDlg.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "Tilt Sensing.h"
#include "Tilt SensingDlg.h"
#include "afxdialogex.h"
#include "mmsystem.h"

#include "math.h"
#include "mathe.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTiltSensingDlg-Dialogfeld




CTiltSensingDlg::CTiltSensingDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTiltSensingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTiltSensingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_DEVICE, m_Devices);
}

BEGIN_MESSAGE_MAP(CTiltSensingDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_RUN, &CTiltSensingDlg::OnBnClickedButtonRun)
	ON_CBN_SELCHANGE(IDC_COMBO_DEVICE, &CTiltSensingDlg::OnCbnSelchangeComboDevice)
	ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CTiltSensingDlg-Meldungshandler

BOOL CTiltSensingDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden


	CString serial[32];
	EnumHidDevices(DEVICE_JW24F14_PID, CODEMERCS_VID, serial);

	for(int i=0; i<32; i++)
	{
		if(serial[i] != "")
			m_Devices.AddString(serial[i]);
	}
	

	m_Font1.CreateFontW(24, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Segoe UI"));
	GetDlgItem(IDC_STATIC_HEADER)->SetFont(&m_Font1);

	m_Font2.CreateFontW(38, 0, 0, 0, FW_BOLD, FALSE, FALSE, 0, DEFAULT_CHARSET, OUT_CHARACTER_PRECIS,CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, _T("Segoe UI"));
	GetDlgItem(IDC_STATIC_ROLL)->SetFont(&m_Font2);
	GetDlgItem(IDC_STATIC_PITCH)->SetFont(&m_Font2);
	GetDlgItem(IDC_STATIC_TILT)->SetFont(&m_Font2);

	GetDlgItem(IDC_STATIC_X)->SetFont(&m_Font2);
	GetDlgItem(IDC_STATIC_Y)->SetFont(&m_Font2);
	GetDlgItem(IDC_STATIC_Z)->SetFont(&m_Font2);


	m_Run = false;

	hid.HidHandle[PIPE_SENSOR] = NULL;
	hid.HidHandle[PIPE_JOYSTICK] = NULL;

	m_Buffer.angleLast = 0;
	m_Buffer.angleBase = 0;

	return TRUE;  
}

void CTiltSensingDlg::OnPaint()
{
	
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);


	}
	else
	{
		CDialogEx::OnPaint();
	}
	/*
	CPaintDC dc(this); // Gertekontext zum Zeichnen

	// ----------- Rahmen um Textfeld -----------

	// CRect Variable fr die Mae der Steuerelemente
	CRect Rect;

	// Zeiger auf Textfeld holen
	CStatic *pStaticWnd = (CStatic*)GetDlgItem(IDC_STATIC_HEADER);

	// Textfeldgroesse in Bildschirm-Koordinaten holen
	pStaticWnd->GetWindowRect(Rect);

	// Koordinaten nach Client-Koordinaten des Dialogs wandeln
	ScreenToClient(Rect);

	// Rechteck um Textfeld um 3 Pixel vergroessern
	Rect.InflateRect(1,1);

	// Vergrssertes Rechteck mit Farbe ausfllen
	dc.FillRect(Rect,&CBrush(RGB(0, 0, 0)));

	CDialogEx::OnPaint();

	*/
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CTiltSensingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CALLBACK CTiltSensingDlg::TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	CTiltSensingDlg* obj = (CTiltSensingDlg*)dwUser;
	obj->MMTimerHandler(wTimerID);
}  

void CTiltSensingDlg::SetMMTimer(UINT ms)
{
	/*Multimedia-Timer BEGINN*/
	/*****************************************************/
	TIMECAPS tc;
	timeGetDevCaps(&tc, sizeof(TIMECAPS));

	DWORD resolution = min(max(tc.wPeriodMin, 0), tc.wPeriodMax);
	timeBeginPeriod(resolution);    

	idEvent = timeSetEvent(ms, resolution, TimerFunction, (DWORD)this, TIME_PERIODIC); 
	/*****************************************************/
}

void CTiltSensingDlg::KillMMTimer(UINT nIDEvent)
{
	timeKillEvent(idEvent);
	idEvent = 0;
}

void CTiltSensingDlg::GetAngleData()
{
	//Daten Via Sensor-Interface (endpoint 1)
	jw24f14_read_acc_int(hid.HidHandle[PIPE_SENSOR], m_Acceleration.xInt, m_Acceleration.yInt, m_Acceleration.zInt);

	//Pitch Winkel
	m_Sensor.pitch = Winkel_X(m_Acceleration.xInt, m_Acceleration.yInt, m_Acceleration.zInt);

	//Roll Winkel
	m_Sensor.roll = Winkel_Y(m_Acceleration.xInt, m_Acceleration.yInt, m_Acceleration.zInt);

	//Winkel aus X, Y, Z
	m_Sensor.angle = Winkel_Z(m_Acceleration.xInt, m_Acceleration.yInt, m_Acceleration.zInt);
}


void CTiltSensingDlg::MMTimerHandler(UINT nIDEvent)
{
	CString text;

	GetAngleData();

	text.Format(_T("%d"), m_Acceleration.xInt);
	GetDlgItem(IDC_STATIC_X)->SetWindowTextW(text);

	text.Format(_T("%d"), m_Acceleration.yInt);
	GetDlgItem(IDC_STATIC_Y)->SetWindowTextW(text);

	text.Format(_T("%d"), m_Acceleration.zInt);
	GetDlgItem(IDC_STATIC_Z)->SetWindowTextW(text);

	text.Format(_T("X: %0.1f "), m_Sensor.pitch * 180 / PI);
	GetDlgItem(IDC_STATIC_PITCH)->SetWindowTextW(text);

	text.Format(_T("Y: %0.1f "), m_Sensor.roll * 180 / PI);
	GetDlgItem(IDC_STATIC_ROLL)->SetWindowTextW(text);

	text.Format(_T("%0.1f "), abs(abs((m_Sensor.angle * 180 / PI)) -90 ) );	
	GetDlgItem(IDC_STATIC_TILT)->SetWindowTextW(text);
}


void CTiltSensingDlg::OnBnClickedButtonRun()
{
	if(hid.HidHandle[PIPE_SENSOR] != NULL)
	{
		if(!m_Run)
		{
			//Get the setup of the joywarrior24f14

			//m_Setting.offset = jw24f14_get_offset(hid.HidHandle[PIPE_SENSOR]);
			m_Setting.offset = 8192;
			
			//Free jw24f14
			jw24f14_mode(hid.HidHandle[PIPE_SENSOR], MD_FREE);

			CString t;
			t.Format(_T("%d"), m_Setting.offset);

			TRACE(t);

			GetDlgItem(IDC_BUTTON_RUN)->SetWindowTextW(_T("Stopp"));
			m_Run = true;
			SetMMTimer(100);
		}
		else
		{
			GetDlgItem(IDC_BUTTON_RUN)->SetWindowTextW(_T("Run"));
			m_Run = false;
			KillMMTimer(idEvent);
		}
	}
	else
		MessageBox(_T("Please choose a JoyWarrior24F14 device from list."), _T("Error"), MB_OK);
}


void CTiltSensingDlg::OnCbnSelchangeComboDevice()
{
	m_Devices.GetLBText(m_Devices.GetCurSel(), hid.Serial);
	ConnectToUSB2(DEVICE_JW24F14_PID, CODEMERCS_VID, hid.HidHandle, hid.Serial, hid.Capabilities);	//Verbinden zum ausgewhlten Device

	jw24f14_mode(hid.HidHandle[1], MD_FREE);
}


HBRUSH CTiltSensingDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	HBRUSH hBgText = CreateSolidBrush(RGB(255,133,50));

	if(pWnd->GetDlgCtrlID() == IDC_STATIC_HEADER)
	{
		pDC->SetTextColor(RGB(255,255,255));
		pDC->SetBkColor(RGB(255,133,50));

		return hBgText;
	}






	return hbr;
}
