
// Tilt SensingDlg.h: Headerdatei
//

#pragma once

#include "functions_jw24f8.h"
#include "functions_jw24f14.h"
#include "functions_usb.h"
#include "filters.h"


// CTiltSensingDlg-Dialogfeld
class CTiltSensingDlg : public CDialogEx
{
// Konstruktion
public:
	CTiltSensingDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_TILTSENSING_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung


// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()

public:
	CFont m_Font1;
	CFont m_Font2;
	
	CComboBox m_Devices;
	bool m_Run;

	USBDATA hid;

	struct AccData 
	{
		int x;
		int y;
		int z;

		double Gx;
		double Gy;
		double Gz;
	};

	AccData m_Acc;

	MedianData m_Filter;
	f14_setting m_Setting;

private:
	static void CALLBACK TimerFunction(UINT wTimerID, UINT msg, DWORD dwUser, DWORD dw1, DWORD dw2); 
public:
	UINT idEvent;
	void MMTimerHandler(UINT nIDEvent);
	void SetMMTimer(UINT ms);
	void KillMMTimer(UINT nIDEvent);

	
	afx_msg void OnBnClickedButtonRun();
	afx_msg void OnCbnSelchangeComboDevice();

	void GetAngleData();


	struct CalcData
	{
		double roll;
		double pitch;
		double angle;
	};

	struct AccelerationData
	{
		short xInt;
		short yInt;
		short zInt;

		unsigned short xRaw;
		unsigned short yRaw;
		unsigned short zRaw;
	};

	struct MedianBuffer
	{
		double x[64];
		double y[64];
		double z[64];

		double roll[64];
		double pitch[64];
		double angle[64];

		//Aktuell gemessener Wert
		double rollBase;
		double pitchBase;
		double angleBase;

		//Letzter Berechneter Wert
		double rollLast;
		double pitchLast;
		double angleLast;
	};


	CalcData m_Calc;
	CalcData m_Sensor;
	AccelerationData m_Acceleration;
	MedianBuffer m_Buffer;
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};
