#include "stdafx.h"
#include "functions_usb.h"
#include "functions_jw24f14.h"


bool jw24f14_write(HANDLE handle, BYTE command, BYTE address, BYTE data)
{
	UCHAR			WriteBuffer[10];
	UCHAR			ReadBuffer[10];
	BOOL			Result;
	DWORD			BytesWritten = 0;
	DWORD			NumberOfBytesRead = 0;
	HIDP_CAPS		caps;

	caps = GetPreparsedData(handle);

	memset(&WriteBuffer, 0, caps.OutputReportByteLength+1);
	WriteBuffer[0] = 0x00;
	WriteBuffer[1] = command;
	WriteBuffer[2] = address;
	WriteBuffer[3] = data;

	Result = WriteFile(handle, &WriteBuffer, caps.OutputReportByteLength, &BytesWritten, NULL);

	if(Result != NULL){
		return 1;
		memset(&ReadBuffer, 0, caps.InputReportByteLength+1);
		ReadBuffer[0] = 0x00;
	
		ReadFile(handle, &ReadBuffer, caps.InputReportByteLength, &NumberOfBytesRead, NULL);
	}
	else
		return 0;
}


BYTE jw24f14_read(HANDLE handle, BYTE command, BYTE address)
{
	UCHAR			WriteBuffer[10];
	UCHAR			ReadBuffer[10];
	DWORD			BytesWritten = 0;
	DWORD			NumberOfBytesRead = 0;
	BOOL			Result;
	HIDP_CAPS		caps;

	caps = GetPreparsedData(handle);

	HidD_FlushQueue(handle);

	memset(&WriteBuffer, 0, caps.OutputReportByteLength+1);

	WriteBuffer[0] = 0x00; //ReportID
	WriteBuffer[1] = 0x82; //CMD-Mode
	WriteBuffer[2] = address | 0x80; //CMD + Addr

	Result = WriteFile(handle, &WriteBuffer, caps.OutputReportByteLength, &BytesWritten, NULL);

	if(Result != NULL)
	{
		memset(&ReadBuffer, 0, caps.InputReportByteLength+1);
		ReadBuffer[0] = 0x00;
	
		ReadFile(handle, &ReadBuffer, caps.InputReportByteLength, &NumberOfBytesRead, NULL);
		return ReadBuffer[3];
	}
	else
		return 0;
}

//Enable or disable direct connection
void jw24f14_mode(HANDLE handle, bool status)
{
	switch(status){
	case 1:
		jw24f14_write(handle, 0x82, 0x00, 0x00);
		break;
	case 0:
		jw24f14_write(handle, 0x00, 0x00, 0x00);
		break;
	}
}

//Set image writeable
void jw24f14_open_image(HANDLE handle, bool status)
{

	BYTE state;

	state = jw24f14_read(handle, 0x82, 0x0D) & 0xEF;

	switch(status){
	case 1:
		jw24f14_write(handle, 0x82, 0x0D, 0x10 | state);
		break;
	case 0:
		jw24f14_write(handle, 0x82, 0x0D, 0x00 | state);
		break;
	}
}

void jw24f14_write_ee(HANDLE handle, BYTE address)
{
	UCHAR			WriteBuffer[10];
	UCHAR			ReadBuffer[10];
	BOOL			Result;
	DWORD			BytesWritten = 0;
	DWORD			NumberOfBytesRead = 0;
	HIDP_CAPS		caps;

	caps = GetPreparsedData(handle);

	memset(&WriteBuffer, 0, caps.OutputReportByteLength+1);
	WriteBuffer[0] = 0x00;
	WriteBuffer[1] = 0x82;
	WriteBuffer[2] = address & 0xFE;

	Result = WriteFile(handle, &WriteBuffer, caps.OutputReportByteLength, &BytesWritten, NULL);

	memset(&ReadBuffer, 0, caps.InputReportByteLength+1);
	ReadBuffer[0] = 0x00;
	
	ReadFile(handle, &ReadBuffer, caps.InputReportByteLength, &NumberOfBytesRead, NULL);
}

void jw24f14_get_image(HANDLE handle, BYTE image[60])
{

	for(int i=0; i<60; i++)
	{
		image[i] = jw24f14_read(handle, 0x82, i);
	}

}


BYTE StringToByte(CString string)
{
	BYTE ret, ret1, exec;
	ret = 0;
	ret1 = 0;
	exec = 0;
	char newvalue[2];

	for(int h=0; h<2; h++)
		newvalue[h] = (char) string.GetAt(h);

	switch(newvalue[1])
	{
	case '0':
		ret = 0;
		break;
	case '1':
		ret = 1;
		break;
	case '2':
		ret = 2;
		break;
	case '3':
		ret = 3;
		break;
	case '4':
		ret = 4;
		break;
	case '5':
		ret = 5;
		break;
	case '6':
		ret = 6;
		break;
	case '7':
		ret = 7;
		break;
	case '8':
		ret = 8;
		break;
	case '9':
		ret = 9;
		break;
	case 'A':
	case 'a':
		ret = 10;
		break;
	case 'B':
	case 'b':
		ret = 11;
		break;
	case 'C':
	case 'c':
		ret = 12;
		break;
	case 'D':
	case 'd':
		ret = 13;
		break;
	case 'E':
	case 'e':
		ret = 14;
		break;
	case 'F':
	case 'f':
		ret = 15;
		break;
	}

	switch(newvalue[0])
	{
	case '0':
		ret1 = 0;
		break;
	case '1':
		ret1 = 16;
		break;
	case '2':
		ret1 = 32;
		break;
	case '3':
		ret1 = 48;
		break;
	case '4':
		ret1 = 64;
		break;
	case '5':
		ret1 = 80;
		break;
	case '6':
		ret1 = 96;
		break;
	case '7':
		ret1 = 112;
		break;
	case '8':
		ret1 = 128;
		break;
	case '9':
		ret1 = 144;
		break;
	case 'A':
	case 'a':
		ret1 = 160;
		break;
	case 'B':
	case 'b':
		ret1 = 176;
		break;
	case 'C':
	case 'c':
		ret1 = 192;
		break;
	case 'D':
	case 'd':
		ret1 = 208;
		break;
	case 'E':
	case 'e':
		ret1 = 224;
		break;
	case 'F':
	case 'f':
		ret1 = 240;
		break;
	}

	exec = ret + ret1;

	return exec;
}

void jw24f14_softreset(HANDLE handle)
{
	jw24f14_open_image(handle, true);
	jw24f14_write(handle, 0x82, 0x10, 0xB6);
}

void jw24f14_update_image(HANDLE handle)
{
	jw24f14_write(handle, 0x82, 0x0D, 0x20);
}

void jw24f14_reset_int(HANDLE handle)
{
	BYTE state;

	state = jw24f14_read(handle, 0x82, 0x0D);
	jw24f14_write(handle, 0x82, 0x0D, 0x40 | state);
}

short jw24f14_read_x(HANDLE handle)
{
	BYTE lsb, msb;
	WORD acc;

	lsb = jw24f14_read(handle, 0x82, 0x02);
	msb = jw24f14_read(handle, 0x82, 0x03);

	acc = ((msb << 8) | lsb) >> 2;

	return acc;
}

short jw24f14_read_y(HANDLE handle)
{
	BYTE lsb, msb;
	WORD acc;

	lsb = jw24f14_read(handle, 0x82, 0x04);
	msb = jw24f14_read(handle, 0x82, 0x05);

	acc = ((msb << 8) | lsb) >> 2;

	return acc;
}

short jw24f14_read_z(HANDLE handle)
{
	BYTE lsb, msb;
	WORD acc;

	lsb = jw24f14_read(handle, 0x82, 0x06);
	msb = jw24f14_read(handle, 0x82, 0x07);

	acc = ((msb << 8) | lsb) >> 2;

	return acc;
}

short jw24f14_read_t(HANDLE handle)
{
	return jw24f14_read(handle, 0x82, 0x08);
}


BYTE jw24f14_get_range(HANDLE handle)
{
	BYTE sub = jw24f14_read(handle, 0x82, 0x35) & 0x0E;
	BYTE ret = sub >> 1;

	return ret;
}

BYTE jw24f14_get_band(HANDLE handle)
{
	BYTE sub = jw24f14_read(handle, 0x82, 0x20) & 0xF0;
	BYTE ret = sub >> 4;

	return ret;
}

CString jw24f14_get_range_str(BYTE range)
{
	if(range == 0) return _T("1G");
	if(range == 1) return _T("1.5G");
	if(range == 2) return _T("2G");
	if(range == 3) return _T("3G");
	if(range == 4) return _T("4G");
	if(range == 5) return _T("8G");
	if(range == 6) return _T("16G");
}

CString jw24f14_get_band_str(BYTE band)
{
	if(band == 0) return _T("10 Hz");
	if(band == 1) return _T("20 Hz");
	if(band == 2) return _T("40 Hz");
	if(band == 3) return _T("75 Hz");
	if(band == 4) return _T("150 Hz");
	if(band == 5) return _T("300 Hz");
	if(band == 6) return _T("600 Hz");
	if(band == 7) return _T("1200 Hz");
	if(band == 8) return _T("High-pass");
	if(band == 9) return _T("Band-pass");
}

short jw24f14_get_offset(HANDLE handle)
{
	if(handle == 0)
		return -1;

	BYTE range = jw24f14_get_range(handle);

	switch(range)
	{
	case RANGE_1G:
		return OFFSET_1G ;
	case RANGE_1_5G:
		return OFFSET_1_5G ;
	case RANGE_2G:
		return OFFSET_2G ;
	case RANGE_3G:
		return OFFSET_3G ;
	case RANGE_4G:
		return OFFSET_4G ;
	case RANGE_8G:
		return OFFSET_8G ;
	case RANGE_16G:
		return OFFSET_16G ;
	//default:
	//	return 0;
	}

}



void jw24f14_set_range(HANDLE handle, BYTE value)
{
	BYTE read = jw24f14_read(handle, 0x82, 0x35) & 0xF1;
	jw24f14_open_image(handle, true);							//ee_w is locked to prevent mal-function. unlock for image and eeprom
	jw24f14_write(handle, 0x82, 0x35, (value << 1) | read);
	jw24f14_open_image(handle, false);
}

void jw24f14_set_band(HANDLE handle, BYTE value)
{
	BYTE read = jw24f14_read(handle, 0x82, 0x20) & 0x0F;
	jw24f14_open_image(handle, true);
	jw24f14_write(handle, 0x82, 0x20, (value << 4) | read);
	jw24f14_open_image(handle, false);
}


BYTE jw24f14_get_offset(HANDLE handle, BYTE axis)
{
	BYTE read = 0x00;

	//0x00: X
	//0x01: Y
	//0x02: Z

	switch(axis)
	{
	case 0x00:
		read = jw24f14_read(handle, 0x82, 0x38);
		break;
	case 0x01:
		read = jw24f14_read(handle, 0x82, 0x39);
		break;
	case 0x02:
		read = jw24f14_read(handle, 0x82, 0x34);
		break;
	}




	return read;
}

BYTE jw24f14_get_lsb_offset(HANDLE handle, BYTE axis)
{
	BYTE read = 0x00;

	//0x00: X
	//0x01: Y
	//0x02: Z

	switch(axis)
	{
	case 0x00:
		read = jw24f14_read(handle, 0x82, 0x35);
		read = (read & 0xF0) >> 4;
		
		break;
	case 0x01:
		read = jw24f14_read(handle, 0x82, 0x36);
		read = read & 0x0F;

		break;
	case 0x02:
		read = jw24f14_read(handle, 0x82, 0x36);
		read = (read & 0xF0) >> 4;

		break;
	}


	return read;
}