extern "C" { 
#include "hidsdi.h" 
#include "setupapi.h"
}

#pragma comment(lib,"hid.lib")
#pragma comment(lib,"setupapi.lib")

#define JW24F8_PID 0x1113
#define JW24F14_PID 0x1116
#define JW24F8_VID 0x07C0
#define JW24F14_VID 0x07C0
#define CODEMERCS_VID 0x07C0

typedef struct USBDATA
{
	HANDLE DeviceHandle;
	HANDLE HidHandle[4];
	HIDP_CAPS Capabilities;
	BYTE PipeOne[10];
	BYTE *PipeOne2[10];
	CString Serial;
	PHIDP_PREPARSED_DATA PreparsedData;
	short NumDevs;
	HIDD_ATTRIBUTES Attributes;

	ULONG vid;
	ULONG pid;
	
} USBDATA;

typedef struct PIPE_ONE
{
	short x, y, z;
} PIPE_ONE;


HIDP_CAPS GetPreparsedData(HANDLE handle);
CString GetSerialNumber(HANDLE handle);
int EnumHidDevices(ULONG productID, ULONG vendorID, CString devSerial[32]);
BOOL ConnectToUSB(ULONG productID, ULONG vendorID, HANDLE &devHandle, HANDLE hidHandle[4], CString &devSerial, HIDP_CAPS &Caps2);
BOOL ConnectToUSB2(ULONG productID, ULONG vendorID, HANDLE hidHandle[4], CString &devSerial, HIDP_CAPS &Caps2);
BOOL WriteData2(HANDLE handle, HIDP_CAPS Caps, UCHAR WBuffer[10], UCHAR RBuffer[10]);
BOOL ReadData2(HANDLE handle, HIDP_CAPS Caps, UCHAR WBuffer[10], UCHAR RBuffer[10]);
BOOL ReadPipOne2(HANDLE handle, HIDP_CAPS Caps, BYTE *RBuffer);
int EnumAllHidDevices(ULONG productID, ULONG vendorID, CString devSerial[32], ULONG devPid[32], CStringArray *SerialArray);
BOOL DevicePresent(HANDLE handle, HIDP_CAPS Caps);